#include "system.h"
#include "app_client.h"
#include "hal_ble_client.h"
#include "hal_ble_host.h"
#include "bsp_time.h"
#include "hal_led.h"
#include "ble_gap.h"
#include "app_host.h"
#include "app_flash.h"
#include "app_client_step.h"
#include "hal_ser_imu_mode_manage.h"
#include "hal_battery.h"
#include "ble_comm.h"

void app_client_DataUpdate_Send(void)
{
	//>> 1(豸)
	//<< 1(): Ь(1)+Ь¶(1)+Ьѹ(4)+Ь(4)+Ь(1)+Ь¶(1)+Ьѹ(4)+Ь(4)
	uint8_t buf[32];
	uint8_t L=0;
	int32_t temperature;
 
	sd_temp_get(&temperature);
	temperature = temperature>>2; 

	//
	buf[L++] = BLE_UPDATE_DATA;
	//Ь
	buf[L++] = GetBatteryPersent();
	buf[L++] = (uint8_t)temperature;
  //ѹ
  buf[L++] = 0;
	buf[L++] = 0;
	buf[L++] = 0;
	buf[L++] = 0;
	
	buf[L++] = (uint8_t)(mFlash.mStep.stepCur[0]>>24);
	buf[L++] = (uint8_t)(mFlash.mStep.stepCur[0]>>16);
	buf[L++] = (uint8_t)(mFlash.mStep.stepCur[0]>>8);
	buf[L++] = (uint8_t)(mFlash.mStep.stepCur[0]>>0);
	//Ь
	buf[L++] = app_host_GetVol_R();
	buf[L++] = app_host_GetTemp_R();
	buf[L++] = (uint8_t)(app_host_GetPress_R()>>24);
	buf[L++] = (uint8_t)(app_host_GetPress_R()>>16);
	buf[L++] = (uint8_t)(app_host_GetPress_R()>>8);
	buf[L++] = (uint8_t)(app_host_GetPress_R()>>0);
	buf[L++] = (uint8_t)(mFlash.mStep.stepCur[1]>>24);
	buf[L++] = (uint8_t)(mFlash.mStep.stepCur[1]>>16);
	buf[L++] = (uint8_t)(mFlash.mStep.stepCur[1]>>8);
	buf[L++] = (uint8_t)(mFlash.mStep.stepCur[1]>>0);
	
	BLE_Client_Tx_Send(0,BLE_UPDATE,buf,L);
}

void app_client_infomation_Send_defineName(uint8_t name[],uint8_t lenth)
{
	//<< 0(豸Ϣ): 豸ͺ(64)+Ьַ(6)+Ӳ汾(2)+汾(2)+Ьַ(6)+Ӳ汾(6)+汾(2)
	ble_gap_addr_t mAddr;
	uint32_t err_code;
	uint8_t buf[128];
	uint8_t L = SHOES_NAME_LEN+1;
	
	memset(buf,0,sizeof(buf));
	//
	buf[0] = BLE_UPDATE_BASEINFO;
	//豸
	for(int i=0;i<lenth;i++){
		buf[i+1] = name[i];
	}
	//MAC ַ
	err_code = sd_ble_gap_addr_get(&mAddr); APP_ERROR_CHECK(err_code);
	//SEGGER_RTT_printf(0,"mac addr:");for(int i=0;i<6;i++){SEGGER_RTT_printf(0,"%02X ",mAddr.addr[i]);}SEGGER_RTT_printf(0,"\n");
	for(int i=0;i<6;i++){
		buf[L++] = mAddr.addr[5-i];
	} 
	//Ӳ汾
	buf[L++] = (uint8_t)((uint32_t)HARDWARE_VERSION>>24);
	buf[L++] = (uint8_t)((uint32_t)HARDWARE_VERSION>>16);
	buf[L++] = (uint8_t)((uint32_t)HARDWARE_VERSION>>8);
	buf[L++] = (uint8_t)((uint32_t)HARDWARE_VERSION>>0);
	//汾
	buf[L++] = SOFTWARE_VERSION;
	
	//Ьmacַ
	for(int i=0;i<6;i++) buf[L++] = mFlash.mClient.macAddr[i];
	
	//ЬӲ汾
	buf[L++] = (uint8_t)((uint32_t)mFlash.mClient.hardVersion>>24);
	buf[L++] = (uint8_t)((uint32_t)mFlash.mClient.hardVersion>>16);
	buf[L++] = (uint8_t)((uint32_t)mFlash.mClient.hardVersion>>8);
	buf[L++] = (uint8_t)((uint32_t)mFlash.mClient.hardVersion>>0);
	//Ь汾
	buf[L++] =  mFlash.mClient.sotfVersion;
	
	BLE_Client_Tx_Send(0,BLE_UPDATE,buf,L);
}

void app_client_infomation_Send(void)
{
	//<< 0(豸Ϣ): 豸ͺ(64)+Ьַ(6)+Ӳ汾(2)+汾(2)+Ьַ(6)+Ӳ汾(6)+汾(2)
	ble_gap_addr_t mAddr;
	uint32_t err_code;
	uint8_t buf[128];
	uint8_t L = SHOES_NAME_LEN+1;
	
	memset(buf,0,sizeof(buf));
	//
	buf[0] = BLE_UPDATE_BASEINFO;
	//豸
	for(int i=0;i<sizeof(SHOES_NAME);i++){
		buf[i+1] = SHOES_NAME[i];
	}
	//MAC ַ
	err_code = sd_ble_gap_addr_get(&mAddr); APP_ERROR_CHECK(err_code);
//	SEGGER_RTT_printf(0,"mac addr:");for(int i=0;i<6;i++){SEGGER_RTT_printf(0,"%02X ",mAddr.addr[i]);}SEGGER_RTT_printf(0,"\n");
	for(int i=0;i<6;i++){
		buf[L++] = mAddr.addr[5-i];
	}
	//Ӳ汾
	buf[L++] = (uint8_t)((uint32_t)HARDWARE_VERSION>>24);
	buf[L++] = (uint8_t)((uint32_t)HARDWARE_VERSION>>16);
	buf[L++] = (uint8_t)((uint32_t)HARDWARE_VERSION>>8);
	buf[L++] = (uint8_t)((uint32_t)HARDWARE_VERSION>>0);
	//汾
	buf[L++] = SOFTWARE_VERSION;
	
	//Ьmacַ
	for(int i=0;i<6;i++) buf[L++] = mFlash.mClient.macAddr[i];
//	SEGGER_RTT_printf(0,"mac addr:");for(int i=0;i<6;i++){SEGGER_RTT_printf(0,"%02X ",mFlash.mClient.macAddr[i]);}SEGGER_RTT_printf(0,"\n");
	//ЬӲ汾
	buf[L++] = (uint8_t)((uint32_t)mFlash.mClient.hardVersion>>24);
	buf[L++] = (uint8_t)((uint32_t)mFlash.mClient.hardVersion>>16);
	buf[L++] = (uint8_t)((uint32_t)mFlash.mClient.hardVersion>>8);
	buf[L++] = (uint8_t)((uint32_t)mFlash.mClient.hardVersion>>0);
	//Ь汾
	buf[L++] = mFlash.mClient.sotfVersion;
	
	BLE_Client_Tx_Send(0,BLE_UPDATE,buf,L);
}

//>> 0xA1: ѯ
void cb_BLE_Client_R_UPDATE(void* handle)
{
	BLE_Client_Rx_t *target = handle;
	uint8_t _cmd = target->pDat[0];
	switch(_cmd){
		case BLE_UPDATE_BASEINFO:{
			//>> 0(豸Ϣ): ʼʱms(8)
			//<< 0(): 豸ͺ(64)+Ьַ(6)+Ӳ汾(2)+汾(2)+Ьַ(6)+Ӳ汾(6)+汾(2)
			//>> AA 06 F9 A1 00 4A
			//<< AA 55 AA A1 00 53 4D 41 52 54 20 53 48 4F 45 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 C1 EB D0 E3 87 47 01 00 01 00 00 00 00 00 00 4F
			app_client_infomation_Send();
			SEGGER_RTT_printf(0,"!!!!!!!!!!!!!!!=======>app_client_infomation_Send\n");
			break;}
		case BLE_UPDATE_DATA:{
			//>> 1(豸)
			//<< 1(): Ь(1)+Ь¶(1)+Ьѹ(4)+Ь(4)+Ь(1)+Ь¶(1)+Ьѹ(4)+Ь(4)
				app_host_GetClientData(20);
			break;}
		case BLE_UPDATE_STEPNUM:{
			//>> 2(ѯ): [0ȫ](2)
			//<< 2(ѯ): +ʼʱms(8)+(2)+(2)+ÿСʱ(4)+...
			if(-1 == hal_ser_imu_mode_manage_get_ready(HAL_SER_IMU_MODE_MANAGE_REALSTEP))app_client_SendStep(target);
			break;}
		case BLE_UPDATE_STEPNUM_CLERA:{
			//>> 3(ɾ): ʼʱms(8)+һķ(1)
			//<< 3(ɾ): ʼʱms(8)+һķ(1)
			BLE_Client_Tx_Send(0,BLE_UPDATE,target->pDat,target->datLen);
			app_client_DeleteStep(target);
			break;}
		default:break;
	}
}

static void app_client_Process(void)
{
	static uint8_t cnt =0;
	if(slave_isconnect()){//ЬЬ
		if(hal_ser_imu_mode_manage_get_ready(HAL_SER_IMU_MODE_MANAGE_GAME) != -1){
			 if(cnt++ >= 4){
				  cnt =0;
				  app_client_DataUpdate_Send();;
			 }
		}
		else app_client_DataUpdate_Send();
	}
}

void app_client_Initialize(void)
{
	BLE_Client_Rx_Regist(BLE_UPDATE,cb_BLE_Client_R_UPDATE);
	app_client_step_Initialize();
	if(0 == mFlash.isHost)Process_Start(2000,"app_client",app_client_Process);
}
