#ifndef __APP_FLASH_H__
#define __APP_FLASH_H__
/*************************************
 *INCLUDES
 */
#include "hal_flash.h"
#include "app_step.h"
#include "exception.h"
#include "app_power.h"
#include "nrf_gpio.h"
#include "nrf_delay.h"
#include "nrf_sdm.h"

/*************************************
 *STRUCTIONS
 */
//__attribute__((packed,aligned(4))) : Ȱʵֽռλ㣬4ֽڶ롣
//size:20
typedef struct __attribute__((packed,aligned(4))) _FlashBackup{
	uint32_t 	head;	
	uint8_t 	macAddr_L[6];
	uint8_t 	macAddr_R[6];
	uint32_t 	hardVersion;
	uint8_t 	sotfVersion;
	uint8_t 	isConfig;
	uint8_t   ErrorStartFlag;
}FlashBackup_t;
//size:36
typedef struct __attribute__((packed,aligned(4))) _FlashStep{
	uint8_t 	startTime[8];				//¼ʱ
	uint8_t 	newStartTime[8];		//ǰʱ
	uint32_t 	stepCur[2];					//ǰò
	uint32_t 	step[2];						//ÿСʱ¼Ьò01
	uint32_t 	num;								//Ѿ¼ÿСʱ
}FlashStep_t;
//size:12
typedef struct __attribute__((packed,aligned(4))) _FlashClient{
	uint8_t 	isConfig;
	uint32_t 	hardVersion;
	uint8_t 	sotfVersion;
	uint8_t	 	macAddr[6];
}FlashClient_t;
//size:
typedef struct __attribute__((packed,aligned(4))) _FlashLog{
	uint8_t Errorflag;
	uint8_t logData[50];
}FlashLog;
//size:64
typedef struct __attribute__((packed,aligned(4))) _Flash_Param{					//ڰ汾޸Ľṹ壬ɾ޸гԱֻ׷µĳԱ																	
	uint32_t 			head;
	uint8_t  			isHost;
	uint8_t 			macHost[6];
	FlashStep_t 	mStep;
	FlashClient_t mClient;
	FlashLog 			mFlashLog;
	uint8_t       Safe_cnt;
	
	uint32_t			m_struct_size;			//ṹС	
	uint32_t			tail_crc16;					//crc16У׼ֻԱ head ~ m_struct_sizeΪδֽ֪ԭtail_crc16δֽ֪ڣĬΪ0Ϊ0ü㡣
}Flash_t;


extern Flash_t mFlash;
extern FlashBackup_t mBackup;

/*1.APIɵݵʱAPIĲĬֵ䣬дصʱAPIĸʽдءݣ
  2.APIݣԼʶǶbuffҪдصʱ򣬽buffԭmemcpyǰݣûʵ֣
*/
 
/********************************************
 *API FUCTIONS
 */
void Flash_Initialize(void);
//洢
uint32_t Flash_SaveStep(void);
//ȡ׵ַ
uint32_t Flash_GetStepZoneStartAddr(void);
//ȡ
uint32_t Flash_GetStep(uint32_t destination_addr, uint32_t *pData, uint32_t dataLen);
//ɾв
uint32_t Flash_DeleteAllStep(void);
//ɾеĻϢ
uint32_t Flash_DeleteAllInformation(void);
//洢Ϣ
uint32_t Flash_SaveInfomation(void);
//ȡϢ
uint32_t Flash_GetInfomation(Flash_t *pflash);
//洢Ϣ
uint32_t Flash_SaveBackup(void);
//ȡϢ
uint32_t Flash_GetBackup(FlashBackup_t *pbackup);
//־Ϣ
uint32_t Flash_SaveLog(uint32_t id, uint32_t pc, uint32_t info);
//־λ
uint8_t Get_isHost(void);
//Խӿ
void TestHalFlashInterface(void);



#endif





























