#ifndef __BSP_FLASH_H__
#define __BSP_FLASH_H__

//flash 1.0V

/*********************************************************************
 * INCLUDES
 */
 
#include "nrf_fstorage.h"
#include "nrf_fstorage_sd.h"
#include "nrf_pwr_mgmt.h"
#include "nrf_soc.h"
#include "nrf_log.h"
#include "app_error.h"
#include "SEGGER_RTT.h"


/*********************************************************************
 * DEFINITIONS
 */
#define FSTORAGE_READ           						0x00																																																		//־λ
#define FSTORAGE_WRITE											0x01																																																		//д־λ

#define START_FSTORAGE_ADDR									0x00074000UL																																														//FLASHʼַ
#define END_FSTORAGE_ADDR										0x00078000UL																																														//FLASHַ

#define FLASH_PAGE_SIZE											4096																																																		//ҳĳ

#define FLASH_PAGE_NUM											((END_FSTORAGE_ADDR - START_FSTORAGE_ADDR)/FLASH_PAGE_SIZE)																							//ҳĸ
#define PAGE_INT_SIZE												(FLASH_PAGE_SIZE/4)																																											//һҳ4ֽڸ

#define FLASH_ZONE_ADDR_1										START_FSTORAGE_ADDR																																											//ҳ1׵ַ
#define FLASH_ZONE_ADDR_2										(FLASH_ZONE_ADDR_1		+FLASH_PAGE_SIZE)																																	//ҳ2׵ַ
#define FLASH_ZONE_ADDR_3										(FLASH_ZONE_ADDR_2		+FLASH_PAGE_SIZE)																																	//ҳ3׵ַ
#define FLASH_ZONE_ADDR_4										(FLASH_ZONE_ADDR_3		+FLASH_PAGE_SIZE)																																	//ҳ4׵ַ

#define FLASH_ZONEADDR_CHECK(zone_addr)			((zone_addr==FLASH_ZONE_ADDR_1 || \
																							zone_addr==FLASH_ZONE_ADDR_2 || \
																							zone_addr==FLASH_ZONE_ADDR_3 || \
																							zone_addr==FLASH_ZONE_ADDR_4)?0:1)																																		//֤ǷҳxķΧ
																							
//ERROR CODE
#define FLASH_OP_SUCCESS										0x00																																																		//flashɹ
#define FLASH_ERROR_ZONEADDR								(FLASH_OP_SUCCESS+0x01)																																									//ַ
#define FLASH_ERROR_ADDROVERBOUNDS					(FLASH_OP_SUCCESS+0x02)																																									//ַԽ
#define FLASH_ERROR_ADDRALIGN								(FLASH_OP_SUCCESS+0x03)																																									//ַ
#define FLASH_ERROR_DATAALIGN								(FLASH_OP_SUCCESS+0x04)																																									//4ֽݲ
#define FLASH_ERROR_DATAEXIST								(FLASH_OP_SUCCESS+0x05)																																									//Ѵ		
#define FLASH_ERROR_PAGENUM									(FLASH_OP_SUCCESS+0x06)																																									//ҳŴ
#define FLASH_ERROR_READ										(FLASH_OP_SUCCESS+0x07)																																									//ȡ
#define FLASH_ERROR_WRITE										(FLASH_OP_SUCCESS+0x08)																																									//д
#define FLASH_ERROR_ERASE										(FLASH_OP_SUCCESS+0x09)																																									//
/*********************************************************************
 * API FUNCTIONS
 */

//FLASHʼ
void 		 Fstorage_FlashInit(void);
//ȡNֽ
uint32_t Read_N_Byte_flash(uint32_t addr , uint32_t *pData, uint32_t dataLen);
//ȡַӦҳ
uint32_t GetPageNum(uint32_t addr, uint16_t *PageNum);
//ҳŲһҳ
uint32_t Erase_OnePage(uint16_t PageNum);
//дN4ֽڣɿҳдӰݣ
uint32_t Write_N_4Byte_flash(uint32_t addr , uint32_t *pdata, uint32_t len);
//дN4ֽڣǰFLASHԤѲ
uint32_t Only_Write_N_4Byte_flash(uint32_t addr , uint32_t *pdata, uint32_t len, bool is_check);
//һҳпдĿռ
uint32_t Find_FreeSpace_In_Page(uint16_t PageNum, uint32_t *start_addr, uint32_t *len);

#endif


