#ifndef __HAL_FLASH_H__
#define __HAL_FLASH_H__


/*************************************
*INCLUDES
*/
#include "bsp_flash.h"
#include "app_step.h"
#include "exception.h"
#include "app_power.h"
#include "nrf_gpio.h"
#include "nrf_delay.h"
#include "nrf_sdm.h"

/*************************************
*DEFINITION
*/
//ERROR CODE
#define ZONE_OP_SUCCESS										0x00																//ZONEɹ
#define ZONE_ERROR_NO_PAGE								(ZONE_OP_SUCCESS+0x01)							//Ҫҳ
#define ZONE_ERROR_PARAM_PAGE_NUM					(ZONE_OP_SUCCESS+0x02)							//ʼҳΪ0С0
#define ZONE_ERROR_NO_INDEX								(ZONE_OP_SUCCESS+0x03)							//ûӦûӦ
#define ZONE_ERROR_READ_FAIL							(ZONE_OP_SUCCESS+0x04)							//ȡʧ
#define ZONE_ERROR_WRITE_FAIL							(ZONE_OP_SUCCESS+0x05)							//дʧ
#define ZONE_ERROR_ERASE_FAIL							(ZONE_OP_SUCCESS+0x06)							//ʧ

/********************************************
*API FUCTIONS
*/
//һ
uint32_t Zone_Alloca(uint8_t page_num, uint32_t *zone_start_addr);
//ȡһָλõ
uint32_t Zone_Read(uint32_t destination_addr, uint32_t *pData, uint32_t dataLen);
//һָλд
uint32_t Zone_Write(uint32_t destination_addr, uint32_t *pData, uint32_t dataLen);
//һ
uint32_t Zone_Erase(uint32_t zone_start_addr);
//ȡһֽڴС
uint32_t Zone_GetByteSize(uint32_t zone_start_addr, uint32_t *bytes);














































#endif

