#ifndef __HAL_SER_IMU_H__
#define __HAL_SER_IMU_H__

#ifdef __cplusplus
extern "C" {
#endif

/*Includes ------------------------------------------------------*/
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"
#include "drv_qmc6310_v2.h"
#include "drv_lsm6ds3tr_c.h"

/*STRUCTION ----------------------------------------------------*/
typedef enum{
	SER_IMU_ACC_ODR_OFF   										= 0,																						//رռٶ									ȼ - 0				ȼԽ󣬼Խ
	
	SER_IMU_ACC_ODR_12HZ5 										= 1,																						//Ƶ - 12.5					ȼ - 1
	
	SER_IMU_ACC_ODR_104HZ 										= 2,																						//Ƶ - 104					ȼ - 2

} SER_IMU_ACC_ODR_e;

typedef enum{
	SER_IMU_GRY_ODR_OFF   										= 0,																						//ر									ȼ - 0				ȼԽ󣬼Խ
	
	SER_IMU_GRY_ODR_12HZ5 										= 1,																						//Ƶ - 12.5					ȼ - 1
	
	SER_IMU_GRY_ODR_104HZ 										= 2,																						//Ƶ - 104					ȼ - 2
	
	
} SER_IMU_GRY_ODR_e;

typedef enum{
	SER_IMU_MAG_ODR_OFF   										= 0,																						//رյشż									ȼ - 0				ȼԽ󣬼Խ
	
	SER_IMU_MAG_ODR_10HZ 											= 1,																						//Ƶ - 10						ȼ - 1
	
	SER_IMU_MAG_ODR_100HZ 										= 2,																						//Ƶ - 100					ȼ - 2
	
	SER_IMU_MAG_ODR_200HZ											=	3,																						//Ƶ - 200					ȼ - 3
	
} SER_IMU_MAG_ODR_e;

typedef enum{
	SER_IMU_FIFO_ODR_OFF   										= 0,																						//رFIFO										ȼ - 0				ȼԽ󣬼Խ
		
	SER_IMU_FIFO_ODR_104HZ 										= 1,																						//Ƶ - 104					ȼ - 1
	
} SER_IMU_FIFO_ODR_e;

typedef enum{
	SER_IMU_ACC_POWER_MODE_HIGH_PERFORMANCE		=	0,																						//ٶȹģʽ - 			ȼ - 0				ȼԽ󣬼Խ
	
	SER_IMU_ACC_POWER_MODE_NORMAL							=	1,																						//ٶȹģʽ - 				ȼ - 1
	
} SER_IMU_ACC_POWER_MODE_e;

typedef enum{
	SER_IMU_GRY_POWER_MODE_HIGH_PERFORMANCE		=	0,																						//ǹģʽ - 			ȼ - 0				ȼԽ󣬼Խ
	
	SER_IMU_GRY_POWER_MODE_NORMAL							=	1,																						//ǹģʽ - 				ȼ - 1
	
} SER_IMU_GRY_POWER_MODE_e;

typedef enum{
	SER_IMU_TIMESTAMP_6MS4										=	0,																						//ʱ - 6.4				ȼ - 0				ȼԽ󣬼Խ
	
	SER_IMU_TIMESTAMP_25US										=	1,																						//ʱ - 25΢					ȼ - 1
	
} SER_IMU_TIMESTAMP_RESOLUTION_e;

typedef enum{
	SER_IMU_TIMESTAMP_OFF											=	0,																						//ʱر									ȼ - 0				ȼԽ󣬼Խ
	
	SER_IMU_TIMESTAMP_ON											=	1,																						//ʱ									ȼ - 1
	
} SER_IMU_TIMESTAMP_SWITCH_e;

typedef enum{
	SER_IMU_ACC_FS_2G													=	0,																						// - 2ٶ				ȼ - 0				ȼԽ󣬼Խ
	
	SER_IMU_ACC_FS_16G   											= 1,																						// - 16ٶ				ȼ - 1
	
} SER_IMU_ACC_FS_e;

typedef enum{
	SER_IMU_GRY_FS_250DPS											=	0,																						// - 250ٶ/					ȼ - 0				ȼԽ󣬼Խ
	
	SER_IMU_GRY_FS_2000DPS	  								= 1,																						// - 2000ٶ/				ȼ - 1
	
} SER_IMU_GRY_FS_e;

typedef enum{
	SER_IMU_MAG_FS_30GS   										= 0,																						// - 30˹								ȼ - 0				ȼԽ󣬼Խ
	
} SER_IMU_MAG_FS_e;

typedef enum{
	SER_IMU_DIR_FRONT													=	0,																						// - ǰ
	
	SER_IMU_DIR_BACK													= 1,																						// - 
	
	SER_IMU_DIR_NUM														=	2,																						// - 
	
} SER_IMU_DIR_e;

typedef struct 
{
	SER_IMU_ACC_POWER_MODE_e									acc_power_mode;																	//ٶȹģʽ
	
	SER_IMU_GRY_POWER_MODE_e									gry_power_mode;																	//ǹģʽ
	
	SER_IMU_FIFO_ODR_e												fifo_odr;																				//FIFOƵ
	
	SER_IMU_TIMESTAMP_RESOLUTION_e						timestamp_resolution;														//ʱ
	
	SER_IMU_TIMESTAMP_SWITCH_e								timestamp_switch;																//ʱأעʱʺFIFOһ	
	
	SER_IMU_ACC_ODR_e													acc_odr;																				//ٶȲƵ
	
	SER_IMU_GRY_ODR_e													gry_odr;																				//ǲƵ
	
	SER_IMU_MAG_ODR_e													mag_odr;																				//شżƲƵ
	
	SER_IMU_ACC_FS_e													acc_fs;																					//ٶ
	
	SER_IMU_GRY_FS_e													gry_fs;																					//
	
	SER_IMU_MAG_FS_e													mag_fs;																					//شż
	
} ser_imu_config_param_t;

typedef struct
{
	int16_t 																	acc[3];																					//ٶ
		
	int16_t 																	gry[3];																					//
	
  int16_t 																	mag[3];																					//شż
	
	int32_t 																	fifo_timestamp;																	//fifoʱ
	
} ser_imu_data_t;

typedef void (*hal_ser_imu_data_update_callback)(int front_num, int back_num);

/*API -------------------------------------------------------*/
/**
	@brief 		ʼIMU
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_Init(void);
/**
	@brief 		ȡIMU
	@param 		p_name 						- [in]	Ϊõ
	@param 		p_handle_id 			- [out]	صķID
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_get_handle(char *p_name, int *p_handle_id);
/**
	@brief 		IMUҪò
	@param 		handle 						- [in]	IMU
	@param 		foot 							- [in]	IMU - ǰ/
	@param 		param 						- [in]	IMUò
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_set_required_param(int handle_id, SER_IMU_DIR_e dir, ser_imu_config_param_t	*param);
/**
	@brief 		IMUòǷ׼
	@param 		foot 							- [in]	IMU - ǰ/
	@param 		param 						- [in]	IMUò
	@return 						- [out]	-1ʧܣ0ɹ
*/
int hal_ser_imu_is_param_get_ready(SER_IMU_DIR_e dir, ser_imu_config_param_t	*param);
/**
	@brief 		ȡIMUǰ
	@param 		dir 							- [in]	IMU - ǰ/
	@return 						- [out]	
*/
int	hal_ser_imu_get_data_num(SER_IMU_DIR_e dir);
/**
	@brief 		ȡIMU
	@param 		dir 							- [in]	IMU - ǰ/
	@param 		index 						- [in]	ڼ
	@param 		pdata 						- [out]	IMU
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_get_data(SER_IMU_DIR_e dir, int index, ser_imu_data_t *pdata);
/**
	@brief 		ݸ֪ͨ
	@param 		p_cb 							- [in]	Ҫصĺ
	@return 						- [out]	-1ʧܣ0ɹ-2Ѵ
*/
int	hal_ser_imu_data_update_notify(hal_ser_imu_data_update_callback p_cb);


#ifdef __cplusplus
}
#endif

#endif








