/*Includes ----------------------------------------------*/
#include "system.h"
#include "hal_ser_imu.h"
#include "hal_ser_imu_mode_manage.h"


/*Private macro ------------------------------------------------------------------------------------------------------------------------------------*/



/*STRUCTION ------------------------------------------------------------------------------------------------------------------------------------*/
typedef struct ser_imu_mode_manage
{
	/*private member*/
	
	int																										mode_switch[HAL_SER_IMU_MODE_MANAGE_NUM];																//ģʽ
	
	int																										ser_imu_handle_id[HAL_SER_IMU_MODE_MANAGE_NUM];													//ģʽIMUID
	
	ser_imu_config_param_t																ser_imu_param[HAL_SER_IMU_MODE_MANAGE_NUM][SER_IMU_DIR_NUM];						//ģʽIMUò
	
	ser_imu_data_t																				ser_imu_data[HAL_SER_IMU_MODE_MANAGE_NUM][SER_IMU_DIR_NUM];							//ģʽIMU
	
} Ser_Imu_Mode_Manage_t;


/*Local Variable ------------------------------------------------------------------------------------------------------------------------------------*/
static Ser_Imu_Mode_Manage_t 		ob_ser_imu_mode_manage;		//ģʽ
	
static ser_imu_config_param_t		imu_power_off_param;			//ػò

/*Local Functions ------------------------------------------------------------------------------------------------------------------------------------*/
static void hal_ser_imu_mode_manage_imu_power_off_init(ser_imu_config_param_t *p_param)
{
	p_param->acc_power_mode 						= SER_IMU_ACC_POWER_MODE_NORMAL;						//ǰ - ٶģʽ
	p_param->gry_power_mode 						= SER_IMU_GRY_POWER_MODE_NORMAL;						//ǰ - ģʽ
	p_param->timestamp_resolution 			= SER_IMU_TIMESTAMP_25US;										//ǰ - ʱ25US
	p_param->timestamp_switch 					= SER_IMU_TIMESTAMP_OFF;										//ǰ - ʱر
	p_param->acc_fs 										= SER_IMU_ACC_FS_16G;												//ǰ - ٶ - 16G
	p_param->gry_fs 										= SER_IMU_GRY_FS_2000DPS;										//ǰ -  - 2000DPS
	p_param->mag_fs 										= SER_IMU_MAG_FS_30GS;											//ǰ - شż - 30GS
	p_param->acc_odr 										= SER_IMU_ACC_ODR_OFF;											// - ٶȲƵ - ر
	p_param->gry_odr 										= SER_IMU_GRY_ODR_OFF;											//ǰ - ǲƵ - ر
	p_param->mag_odr 										= SER_IMU_MAG_ODR_OFF;											//ǰ - شżƲƵ - ر
	p_param->fifo_odr 									= SER_IMU_FIFO_ODR_OFF;											//ǰ - FIFOƵ - ر
}
static void hal_ser_imu_mode_manage_imu_standby_power_init(HAL_SER_IMU_MODE_MANAGE_e mode)
{
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].acc_power_mode 						= SER_IMU_ACC_POWER_MODE_NORMAL;						//ǰ - ٶģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].gry_power_mode 						= SER_IMU_GRY_POWER_MODE_NORMAL;						//ǰ - ģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].timestamp_resolution 			= SER_IMU_TIMESTAMP_25US;										//ǰ - ʱ25US
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].timestamp_switch 					= SER_IMU_TIMESTAMP_OFF;										//ǰ - ʱر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].acc_fs 										= SER_IMU_ACC_FS_16G;												//ǰ - ٶ - 16G
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].gry_fs 										= SER_IMU_GRY_FS_2000DPS;										//ǰ -  - 2000DPS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].mag_fs 										= SER_IMU_MAG_FS_30GS;											//ǰ - شż - 30GS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].acc_odr 									= SER_IMU_ACC_ODR_12HZ5;										//ǰ - ٶȲƵ - 12.5HZ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].gry_odr 									= SER_IMU_GRY_ODR_OFF;											//ǰ - ǲƵ - ر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].mag_odr 									= SER_IMU_MAG_ODR_OFF;											//ǰ - شżƲƵ - ر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].fifo_odr 									= SER_IMU_FIFO_ODR_OFF;											//ǰ - FIFOƵ - ر
	
	
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].acc_power_mode 						= SER_IMU_ACC_POWER_MODE_NORMAL;						// - ٶģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].gry_power_mode 						= SER_IMU_GRY_POWER_MODE_NORMAL;						// - ģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].timestamp_resolution 			= SER_IMU_TIMESTAMP_25US;										// - ʱ25US
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].timestamp_switch 					= SER_IMU_TIMESTAMP_OFF;										// - ʱر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].acc_fs 										= SER_IMU_ACC_FS_16G;												// - ٶ - 16G
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].gry_fs 										= SER_IMU_GRY_FS_2000DPS;										// -  - 2000DPS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].mag_fs 										= SER_IMU_MAG_FS_30GS;											// - شż - 30GS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].acc_odr 										= SER_IMU_ACC_ODR_OFF;											// - ٶȲƵ - ر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].gry_odr 										= SER_IMU_GRY_ODR_OFF;											// - ǲƵ - ر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].mag_odr 										= SER_IMU_MAG_ODR_10HZ;										  // - شżƲƵ - 10HZ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].fifo_odr 									= SER_IMU_FIFO_ODR_OFF;											// - FIFOƵ - ر
}

static void hal_ser_imu_mode_manage_imu_low_power_init(HAL_SER_IMU_MODE_MANAGE_e mode)
{
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].acc_power_mode 						= SER_IMU_ACC_POWER_MODE_NORMAL;						//ǰ - ٶģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].gry_power_mode 						= SER_IMU_GRY_POWER_MODE_NORMAL;						//ǰ - ģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].timestamp_resolution 			= SER_IMU_TIMESTAMP_25US;										//ǰ - ʱ25US
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].timestamp_switch 					= SER_IMU_TIMESTAMP_OFF;										//ǰ - ʱر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].acc_fs 										= SER_IMU_ACC_FS_16G;												//ǰ - ٶ - 16G
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].gry_fs 										= SER_IMU_GRY_FS_2000DPS;										//ǰ -  - 2000DPS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].mag_fs 										= SER_IMU_MAG_FS_30GS;											//ǰ - شż - 30GS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].acc_odr 									= SER_IMU_ACC_ODR_104HZ;										//ǰ - ٶȲƵ - 104HZ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].gry_odr 									= SER_IMU_GRY_ODR_OFF;											//ǰ - ǲƵ - ر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].mag_odr 									= SER_IMU_MAG_ODR_100HZ;										//ǰ - شżƲƵ - 100HZ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].fifo_odr 									= SER_IMU_FIFO_ODR_104HZ;										//ǰ - FIFOƵ - 104HZ
	
	
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].acc_power_mode 						= SER_IMU_ACC_POWER_MODE_NORMAL;						// - ٶģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].gry_power_mode 						= SER_IMU_GRY_POWER_MODE_NORMAL;						// - ģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].timestamp_resolution 			= SER_IMU_TIMESTAMP_25US;										// - ʱ25US
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].timestamp_switch 					= SER_IMU_TIMESTAMP_OFF;										// - ʱر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].acc_fs 										= SER_IMU_ACC_FS_16G;												// - ٶ - 16G
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].gry_fs 										= SER_IMU_GRY_FS_2000DPS;										// -  - 2000DPS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].mag_fs 										= SER_IMU_MAG_FS_30GS;											// - شż - 30GS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].acc_odr 										= SER_IMU_ACC_ODR_OFF;											// - ٶȲƵ - ر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].gry_odr 										= SER_IMU_GRY_ODR_OFF;											// - ǲƵ - ر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].mag_odr 										= SER_IMU_MAG_ODR_OFF;											// - شżƲƵ - ر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].fifo_odr 									= SER_IMU_FIFO_ODR_OFF;											// - FIFOƵ - ر
}

static void hal_ser_imu_mode_manage_imu_full_power_init(HAL_SER_IMU_MODE_MANAGE_e mode)
{
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].acc_power_mode 						= SER_IMU_ACC_POWER_MODE_NORMAL;						//ǰ - ٶģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].gry_power_mode 						= SER_IMU_GRY_POWER_MODE_NORMAL;						//ǰ - ģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].timestamp_resolution 			= SER_IMU_TIMESTAMP_25US;										//ǰ - ʱ25US
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].timestamp_switch 					= SER_IMU_TIMESTAMP_ON;											//ǰ - ʱ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].acc_fs 										= SER_IMU_ACC_FS_16G;												//ǰ - ٶ - 16G
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].gry_fs 										= SER_IMU_GRY_FS_2000DPS;										//ǰ -  - 2000DPS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].mag_fs 										= SER_IMU_MAG_FS_30GS;											//ǰ - شż - 30GS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].acc_odr 									= SER_IMU_ACC_ODR_104HZ;										//ǰ - ٶȲƵ - 104HZ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].gry_odr 									= SER_IMU_GRY_ODR_104HZ;										//ǰ - ǲƵ - 104HZ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].mag_odr 									= SER_IMU_MAG_ODR_200HZ;										//ǰ - شżƲƵ - 200HZ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT].fifo_odr 									= SER_IMU_FIFO_ODR_104HZ;										//ǰ - FIFOƵ - 104HZ
	
	
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].acc_power_mode 						= SER_IMU_ACC_POWER_MODE_NORMAL;						// - ٶģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].gry_power_mode 						= SER_IMU_GRY_POWER_MODE_NORMAL;						// - ģʽ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].timestamp_resolution 			= SER_IMU_TIMESTAMP_25US;										// - ʱ25US
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].timestamp_switch 					= SER_IMU_TIMESTAMP_OFF;										// - ʱر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].acc_fs 										= SER_IMU_ACC_FS_16G;												// - ٶ - 16G
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].gry_fs 										= SER_IMU_GRY_FS_2000DPS;										// -  - 2000DPS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].mag_fs 										= SER_IMU_MAG_FS_30GS;											// - شż - 30GS
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].acc_odr 										= SER_IMU_ACC_ODR_OFF;											// - ٶȲƵ - ر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].gry_odr 										= SER_IMU_GRY_ODR_OFF;											// - ǲƵ - ر
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].mag_odr 										= SER_IMU_MAG_ODR_200HZ;										// - شżƲƵ - 200HZ
	ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK].fifo_odr 									= SER_IMU_FIFO_ODR_OFF;											// - FIFOƵ - ر
}

static void hal_ser_imu_mode_manage_printf_Process(void)
{
	SEGGER_RTT_printf(0,"hal_ser_imu_mode_manage----------------------------------------------------------------->\n");
	
	SEGGER_RTT_printf(0,"mode_switch:%d,%d,%d,%d,%d\n",ob_ser_imu_mode_manage.mode_switch[HAL_SER_IMU_MODE_MANAGE_STANDBY], \
																										 ob_ser_imu_mode_manage.mode_switch[HAL_SER_IMU_MODE_MANAGE_NORMAL], \
																										 ob_ser_imu_mode_manage.mode_switch[HAL_SER_IMU_MODE_MANAGE_SELF_CHECK], \
																										 ob_ser_imu_mode_manage.mode_switch[HAL_SER_IMU_MODE_MANAGE_GAME], \
																										 ob_ser_imu_mode_manage.mode_switch[HAL_SER_IMU_MODE_MANAGE_REALSTEP]);
	
	SEGGER_RTT_printf(0,"<-----------------------------------------------------------------hal_ser_imu_mode_manage\n");
}

/*API ------------------------------------------------------------------------------------------------------------------------------------*/
/**
	@brief 		ʼģʽ
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_mode_manage_Init(void)
{
	int ret = 0;
	//ʼimu
	if(hal_ser_imu_Init() == -1)ret = -1;
	
	//ģʽṹ
	memset(&ob_ser_imu_mode_manage, 0, sizeof(ob_ser_imu_mode_manage));
	
	/*ʼģʽṹ*/
	
	//ʼ-ģʽ
	ob_ser_imu_mode_manage.mode_switch[HAL_SER_IMU_MODE_MANAGE_STANDBY] = 0;																																			//ģʽر
	hal_ser_imu_get_handle("HAL_SER_IMU_MODE_MANAGE_STANDBY", &ob_ser_imu_mode_manage.ser_imu_handle_id[HAL_SER_IMU_MODE_MANAGE_STANDBY]);				//ȡIMUID
	hal_ser_imu_mode_manage_imu_standby_power_init(HAL_SER_IMU_MODE_MANAGE_STANDBY);																															//IMUò	-	
	
	//ʼ-ģʽ
	ob_ser_imu_mode_manage.mode_switch[HAL_SER_IMU_MODE_MANAGE_NORMAL] = 0;																																				//ģʽر
	hal_ser_imu_get_handle("HAL_SER_IMU_MODE_MANAGE_NORMAL", &ob_ser_imu_mode_manage.ser_imu_handle_id[HAL_SER_IMU_MODE_MANAGE_NORMAL]);					//ȡIMUID
	hal_ser_imu_mode_manage_imu_low_power_init(HAL_SER_IMU_MODE_MANAGE_NORMAL);																																		//IMUò	-	͹
	
	//ʼ-Լģʽ
	ob_ser_imu_mode_manage.mode_switch[HAL_SER_IMU_MODE_MANAGE_SELF_CHECK] = 0;																																		//ģʽر
	hal_ser_imu_get_handle("HAL_SER_IMU_MODE_MANAGE_SELF_CHECK", &ob_ser_imu_mode_manage.ser_imu_handle_id[HAL_SER_IMU_MODE_MANAGE_SELF_CHECK]);	//ȡIMUID
	hal_ser_imu_mode_manage_imu_full_power_init(HAL_SER_IMU_MODE_MANAGE_SELF_CHECK);																															//IMUò	-	ȫ
	
	//ʼ-Ϸģʽ
	ob_ser_imu_mode_manage.mode_switch[HAL_SER_IMU_MODE_MANAGE_GAME] = 0;																																					//ģʽر
	hal_ser_imu_get_handle("HAL_SER_IMU_MODE_MANAGE_GAME", &ob_ser_imu_mode_manage.ser_imu_handle_id[HAL_SER_IMU_MODE_MANAGE_GAME]);							//ȡIMUID
	hal_ser_imu_mode_manage_imu_full_power_init(HAL_SER_IMU_MODE_MANAGE_GAME);																																		//IMUò	-	ȫ
	
	//ʼ-У׼ģʽ
	ob_ser_imu_mode_manage.mode_switch[HAL_SER_IMU_MODE_MANAGE_CALIBRATION] = 0;																																	//ģʽر
	hal_ser_imu_get_handle("HAL_SER_IMU_MODE_MANAGE_CALIBRATION", &ob_ser_imu_mode_manage.ser_imu_handle_id[HAL_SER_IMU_MODE_MANAGE_CALIBRATION]);//ȡIMUID
	hal_ser_imu_mode_manage_imu_full_power_init(HAL_SER_IMU_MODE_MANAGE_CALIBRATION);	
	
	//ʼ-ʵʱƲģʽ
	ob_ser_imu_mode_manage.mode_switch[HAL_SER_IMU_MODE_MANAGE_REALSTEP] = 0;																																			//ģʽر
	hal_ser_imu_get_handle("HAL_SER_IMU_MODE_MANAGE_REALSTEP", &ob_ser_imu_mode_manage.ser_imu_handle_id[HAL_SER_IMU_MODE_MANAGE_REALSTEP]);			//ȡIMUID
	hal_ser_imu_mode_manage_imu_full_power_init(HAL_SER_IMU_MODE_MANAGE_REALSTEP);																																//IMUò	-	ȫ
	
	//ʼػò
	hal_ser_imu_mode_manage_imu_power_off_init(&imu_power_off_param);
	
	SEGGER_RTT_printf(0,"sizeof(%d)\n",sizeof(ob_ser_imu_mode_manage));
	
//	Process_Start(1000,"hal_ser_imu_mode_manage_printf_Process",hal_ser_imu_mode_manage_printf_Process);
	
	if(ret == -1)return -1;
	
	return 0;
}
/**
	@brief 		Ҫģʽ
	@param 		mode							-	[in]	Ҫģʽ
	@param 		imu_mode_switch		-	[in]	ģʽ
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_mode_manage_set_required(HAL_SER_IMU_MODE_MANAGE_e mode, HAL_SER_IMU_MODE_MANAGE_IMU_MODE_SWITCH_e imu_mode_switch)
{
	//ģʽܳģʽ
	if(mode >= HAL_SER_IMU_MODE_MANAGE_NUM)return -1;
	
	//ģʽ
	switch(imu_mode_switch)
	{
		case HAL_SER_IMU_MODE_MANAGE_IMU_MODE_ON:
			if(ob_ser_imu_mode_manage.mode_switch[mode] == 0)ob_ser_imu_mode_manage.mode_switch[mode]++;
			break;
		
		case HAL_SER_IMU_MODE_MANAGE_IMU_MODE_OFF:
			if(ob_ser_imu_mode_manage.mode_switch[mode] != 0)ob_ser_imu_mode_manage.mode_switch[mode]--;
			break;
	}
	
	//øģʽµ
	for(int i = 0; i < HAL_SER_IMU_MODE_MANAGE_NUM; i++)
	{
		if(ob_ser_imu_mode_manage.mode_switch[i] > 0)//ģʽ
		{
			//ǰIMUò
			if(hal_ser_imu_set_required_param(ob_ser_imu_mode_manage.ser_imu_handle_id[i], SER_IMU_DIR_FRONT, &ob_ser_imu_mode_manage.ser_imu_param[i][SER_IMU_DIR_FRONT]) == -1)return -1;
			//úIMUò
			if(hal_ser_imu_set_required_param(ob_ser_imu_mode_manage.ser_imu_handle_id[i], SER_IMU_DIR_BACK, &ob_ser_imu_mode_manage.ser_imu_param[i][SER_IMU_DIR_BACK]) == -1)return -1;
		}
		else	//ģʽر
		{
			//ǰIMUò
			if(hal_ser_imu_set_required_param(ob_ser_imu_mode_manage.ser_imu_handle_id[i], SER_IMU_DIR_FRONT, &imu_power_off_param) == -1)return -1;
			//úIMUò
			if(hal_ser_imu_set_required_param(ob_ser_imu_mode_manage.ser_imu_handle_id[i], SER_IMU_DIR_BACK, &imu_power_off_param) == -1)return -1;
		}
	}

	return 0;
}
/**
	@brief 		ģʽǷ׼
	@param 		mode							-	[in]	Ҫģʽ
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_mode_manage_get_ready(HAL_SER_IMU_MODE_MANAGE_e mode)
{
	//ģʽܳģʽ
	if(mode >= HAL_SER_IMU_MODE_MANAGE_NUM)return -1;
	
	if(ob_ser_imu_mode_manage.mode_switch[mode] == 0)
	{
		return -1;
	}
	else
	{
		//жǰIMUòǷ׼
		if(hal_ser_imu_is_param_get_ready(SER_IMU_DIR_FRONT, &ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_FRONT]) != -1)
		{
			//жϺIMUòǷ׼
			if(hal_ser_imu_is_param_get_ready(SER_IMU_DIR_BACK, &ob_ser_imu_mode_manage.ser_imu_param[mode][SER_IMU_DIR_BACK]) != -1)
			{
				return 0;
			}
		}
	}
	
	return -1;
}
/**
	@brief 		ȡǰģʽIMUǰ
	@param 		mode							-	[in]	Ҫģʽ
	@param 		dir 							- [in]	IMU - ǰ/
	@return 						- [out]	
*/
int	hal_ser_imu_mode_manage_get_data_num(SER_IMU_DIR_e dir)
{
	return hal_ser_imu_get_data_num(dir);
}
/**
	@brief 		ȡǰģʽIMU
	@param 		dir 							- [in]	IMU - ǰ/
	@param 		index 						- [in]	ڼ
	@param 		pdata 						- [out]	IMU
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_mode_manage_get_data(SER_IMU_DIR_e dir, int index, ser_imu_data_t *pdata)
{
	return hal_ser_imu_get_data(dir, index, pdata);
}

/**
	@brief 		ѯǰǷģʽ
	@return 						- [out]	-1 ǹģʽ0 ģʽ
*/
int	hal_ser_imu_mode_IsSuspend(void)
{
	 for(uint8_t i = HAL_SER_IMU_MODE_MANAGE_STANDBY;i< HAL_SER_IMU_MODE_MANAGE_NUM;i++){
	     if( 0 == hal_ser_imu_mode_manage_get_ready((HAL_SER_IMU_MODE_MANAGE_e)i)){
				  return -1;
			 }
	 }
	 return 0;
}






























