#ifndef __HAL_SER_IMU_MODE_MANAGE_H__
#define __HAL_SER_IMU_MODE_MANAGE_H__

#ifdef __cplusplus
extern "C" {
#endif

/*Includes ------------------------------------------------------*/
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"
#include "hal_ser_imu.h"																

/*STRUCTION ----------------------------------------------------*/
typedef enum
{
	HAL_SER_IMU_MODE_MANAGE_IMU_MODE_ON 	= true,																												//ģʽ
	
	HAL_SER_IMU_MODE_MANAGE_IMU_MODE_OFF 	= false,																											//ģʽر
	
} HAL_SER_IMU_MODE_MANAGE_IMU_MODE_SWITCH_e;
typedef enum 
{
	HAL_SER_IMU_MODE_MANAGE_STANDBY = 0,																																//ģʽЬ
	
	HAL_SER_IMU_MODE_MANAGE_NORMAL,																																			//ģʽЬ
	
	HAL_SER_IMU_MODE_MANAGE_SELF_CHECK,																																	//Լģʽ
	
	HAL_SER_IMU_MODE_MANAGE_GAME,																																				//Ϸģʽ
	
	HAL_SER_IMU_MODE_MANAGE_REALSTEP,																																		//ʵʱƲģʽ
	
	HAL_SER_IMU_MODE_MANAGE_CALIBRATION,																																//У׼ģʽ
	
	HAL_SER_IMU_MODE_MANAGE_NUM,																																				//ģʽ
	
} HAL_SER_IMU_MODE_MANAGE_e;

/*API -------------------------------------------------------*/
/**
	@brief 		ʼģʽ
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_mode_manage_Init(void);
/**
	@brief 		Ҫģʽ
	@param 		mode							-	[in]	Ҫģʽ
	@param 		imu_mode_switch		-	[in]	ģʽ
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_mode_manage_set_required(HAL_SER_IMU_MODE_MANAGE_e mode, HAL_SER_IMU_MODE_MANAGE_IMU_MODE_SWITCH_e imu_mode_switch);
/**
	@brief 		ģʽǷ׼
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_mode_manage_get_ready(HAL_SER_IMU_MODE_MANAGE_e mode);
/**
	@brief 		ȡǰģʽIMUǰ
	@param 		mode							-	[in]	Ҫģʽ
	@param 		dir 							- [in]	IMU - ǰ/
	@return 						- [out]	
*/
int	hal_ser_imu_mode_manage_get_data_num(SER_IMU_DIR_e dir);
/**
	@brief 		ȡǰģʽIMU
	@param 		dir 							- [in]	IMU - ǰ/
	@param 		index 						- [in]	ڼ
	@param 		pdata 						- [out]	IMU
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_ser_imu_mode_manage_get_data(SER_IMU_DIR_e dir, int index, ser_imu_data_t *pdata);

/**
	@brief 		ѯǰǷģʽ
	@return 						- [out]	-1 ǹģʽ0 ģʽ
*/
int	hal_ser_imu_mode_IsSuspend(void);






#ifdef __cplusplus
}
#endif

#endif

















